## osg2vsg 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(osg2vsg
    VERSION 0.3.0
    DESCRIPTION "OpenSceneGraph/VulkanSceneGraph integration library"
    LANGUAGES CXX
)
set(OSG2VSG_SOVERSION 0)
SET(OSG2VSG_RELEASE_CANDIDATE 0)

set(OpenGL_GL_PREFERENCE "GLVND")
find_package(OpenGL REQUIRED)

# Find OpenSceneGraph packages for reference
# set preference for using modern OpenGL library.
find_package(OpenSceneGraph REQUIRED COMPONENTS osgDB osgTerrain osgUtil osgGA osgViewer)

if (VULKAN_SDK)
    set(ENV{VULKAN_SDK} ${VULKAN_SDK})
endif()

find_package(vsg 1.1.2)

vsg_setup_dir_vars()
vsg_setup_build_vars()

vsg_add_target_clang_format(
    FILES
        ${PROJECT_SOURCE_DIR}/include/*/*.h
        ${PROJECT_SOURCE_DIR}/src/*/*.cpp
)
vsg_add_target_clobber()
vsg_add_target_cppcheck(
    FILES
        ${PROJECT_SOURCE_DIR}/include/*/*.h
        ${PROJECT_SOURCE_DIR}/src/*/*.cpp
        -I ${PROJECT_SOURCE_DIR}/include/
)
vsg_add_target_docs(
    FILES
        ${PROJECT_SOURCE_DIR}/include/
)
vsg_add_target_uninstall()


# only provide custom targets if not building as a submodule/FetchContent
if (${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR})

    vsg_add_option_maintainer(
        PREFIX v
        RCLEVEL ${OSG2VSG_RELEASE_CANDIDATE}
    )

endif()

# src directory contains all the example applications etc.
add_subdirectory(src/osg2vsg)
add_subdirectory(src/osgPlugins/vsg)
add_subdirectory(applications)

=== applications/CMakeLists.txt ===
# set the use of C++17 globally as all examples require it
set(CMAKE_CXX_STANDARD 17)

add_subdirectory(osggroups)
add_subdirectory(osgmaths)
add_subdirectory(vsgnodes)
add_subdirectory(vsgobjects)
add_subdirectory(vsgwithosg)

=== applications/osggroups/CMakeLists.txt ===
find_package(OpenGL)

if(WIN32)
    set(OPENGL_LIBRARY ${OPENGL_gl_LIBRARY})
else()
    set(OPENGL_LIBRARY OpenGL::GL)
endif()

if(NOT ANDROID)
    find_package(Threads)
endif()

if (UNIX)
    find_library(DL_LIBRARY dl)
endif()

set(SOURCES osggroups.cpp)

add_executable(osggroups ${SOURCES})
target_include_directories(osggroups PRIVATE ${OSG_INCLUDE_DIR})
target_link_libraries(osggroups ${OSGDB_LIBRARIES} ${OSG_LIBRARIES} ${OPENTHREADS_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${OPENGL_LIBRARY} ${DL_LIBRARY})

=== applications/osgmaths/CMakeLists.txt ===
find_package(OpenGL)

if(WIN32)
    set(OPENGL_LIBRARY ${OPENGL_gl_LIBRARY})
else()
    set(OPENGL_LIBRARY OpenGL::GL)
endif()

if(NOT ANDROID)
    find_package(Threads)
endif()

if (UNIX)
    find_library(DL_LIBRARY dl)
endif()

set(SOURCES osgmaths.cpp)

add_executable(osgmaths ${SOURCES})
target_include_directories(osgmaths PRIVATE ${OSG_INCLUDE_DIR})
target_link_libraries(osgmaths
    vsg::vsg
    ${OSGDB_LIBRARIES} ${OSG_LIBRARIES} ${OPENTHREADS_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${OPENGL_LIBRARY} ${DL_LIBRARY}
)

=== applications/vsgnodes/CMakeLists.txt ===
set(SOURCES vsgnodes.cpp)

add_executable(vsgnodes ${SOURCES})
target_include_directories(vsgnodes PRIVATE ${OSG_INCLUDE_DIR})
target_link_libraries(vsgnodes vsg::vsg ${OSG_LIBRARIES})

=== applications/vsgobjects/CMakeLists.txt ===
set(SOURCES vsgobjects.cpp)

add_executable(vsgobjects ${SOURCES})
target_include_directories(vsgobjects PRIVATE ${OSG_INCLUDE_DIR})
target_link_libraries(vsgobjects vsg::vsg ${OSG_LIBRARIES})

=== applications/vsgwithosg/CMakeLists.txt ===
set(SOURCES
    GLMemoryExtensions.cpp
    GLSemaphore.cpp
    SharedTexture.cpp
    vsgwithosg.cpp
)

add_executable(vsgwithosg ${SOURCES})

target_include_directories(vsgwithosg PRIVATE ${OSG_INCLUDE_DIR})
target_link_libraries(vsgwithosg
    vsg::vsg
    osg2vsg
    ${OPENTHREADS_LIBRARIES}
    ${OSG_LIBRARIES}
    ${OSGUTIL_LIBRARIES}
    ${OSGDB_LIBRARIES}
    ${OSGGA_LIBRARIES}
    ${OSGVIEWER_LIBRARIES}
    ${OPENGL_LIBRARIES}
)

=== src/osg2vsg/CMakeLists.txt ===

SET(HEADER_PATH ${PROJECT_SOURCE_DIR}/include/osg2vsg)

set(HEADERS
    ${HEADER_PATH}/Export.h
    ${HEADER_PATH}/OSG.h
)

set(SOURCES
    convert.cpp
    BuildOptions.cpp
    ConvertToVsg.cpp
    GeometryUtils.cpp
    ImageUtils.cpp
    Optimize.cpp
    OSG.cpp
    SceneAnalysis.cpp
    SceneBuilder.cpp
    ShaderUtils.cpp
)

add_library(osg2vsg ${HEADERS} ${SOURCES})

# add definitions to enable building osg2vsg as part of submodule
add_library(osg2vsg::osg2vsg ALIAS osg2vsg)
set(osg2vsg_FOUND TRUE CACHE INTERNAL "osg2vsg found.")
set(CMAKE_DISABLE_FIND_PACKAGE_osg2vsg TRUE CACHE INTERNAL "Disable find_package(osg2vsg) as it's not necessary.")

set_property(TARGET osg2vsg PROPERTY VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})
set_property(TARGET osg2vsg PROPERTY SOVERSION ${OSG2VSG_SOVERSION})
set_property(TARGET osg2vsg PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET osg2vsg PROPERTY CXX_STANDARD 17)

target_include_directories(osg2vsg PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:include>
    ${OSG_INCLUDE_DIR}
)

target_link_libraries(osg2vsg
    PUBLIC
        vsg::vsg
    PRIVATE
        ${OPENTHREADS_LIBRARIES} ${OSG_LIBRARIES} ${OSGUTIL_LIBRARIES} ${OSGDB_LIBRARIES} ${OSGTERRAIN_LIBRARIES}
)


install(TARGETS osg2vsg ${INSTALL_TARGETS_DEFAULT_FLAGS})

target_compile_definitions(osg2vsg PRIVATE ${EXTRA_DEFINES})

if (BUILD_SHARED_LIBS)
    target_compile_definitions(osg2vsg INTERFACE OSG2VSG_SHARED_LIBRARY)
endif()

install(DIRECTORY ${HEADER_PATH} DESTINATION include)

vsg_add_cmake_support_files(
    CONFIG_TEMPLATE osg2vsgConfig.cmake
)

=== src/osgPlugins/vsg/CMakeLists.txt ===
set(SOURCES
    ReaderWriterVSG.cpp
)

add_library(osgdb_vsg MODULE ${SOURCES})
set_property(TARGET osgdb_vsg PROPERTY CXX_STANDARD 17)

target_include_directories(osgdb_vsg PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    ${OSG_INCLUDE_DIR}
)

target_link_libraries(osgdb_vsg PUBLIC
    osg2vsg
    vsg::vsg
    ${OPENTHREADS_LIBRARIES} ${OSG_LIBRARIES} ${OSGUTIL_LIBRARIES} ${OSGDB_LIBRARIES}
)

# osg plugins related
set(OSG_PLUGINS_DIRECTORY osgPlugins-${OPENSCENEGRAPH_VERSION})
if(CYGWIN)
    set(OSG_PLUGIN_PREFIX "cygwin_")
elseif(MINGW)
    set(OSG_PLUGIN_PREFIX "mingw_")
else()
    set(OSG_PLUGIN_PREFIX "")
endif()
set(CMAKE_SHARED_MODULE_PREFIX ${OSG_PLUGIN_PREFIX})

if(WIN32)
    set(OSG_PLUGIN_INSTALL_LIBDIR ${CMAKE_INSTALL_BINDIR})
else()
    set(OSG_PLUGIN_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
endif()

# do not use INSTALL_TARGETS_DEFAULT_FLAGS, it does not match
install(TARGETS osgdb_vsg EXPORT osg2vsgTargets
    LIBRARY DESTINATION ${OSG_PLUGIN_INSTALL_LIBDIR}/${OSG_PLUGINS_DIRECTORY}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}/${OSG_PLUGINS_DIRECTORY}
    RUNTIME DESTINATION bin
    INCLUDES DESTINATION include
)

=== debian/changelog ===
osg2vsg (0.3.0-1+11.29) unstable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Sat, 04 Oct 2025 05:37:02 +0000

osg2vsg (0.0.0) unstable; urgency=low

  * Initial build

 -- Rene van Paassen <Rene.vanPaassen@gmail.com>  Thu, 14 Jul 2022 16:00:00 +0200

=== debian/control ===
Source: osg2vsg
Section: unknown
Priority: extra
Maintainer: Rene van Paassen <Rene.vanPaassen@gmail.com>
Build-Depends: debhelper (>= 10), cdbs, cmake, pkg-config, gcc, libvulkan-dev,  libvulkanscenegraph-dev, libfreetype-dev, libassimp-dev, libopenexr-dev, libgdal-dev, libcurl4-openssl-dev, libopenscenegraph-dev

Package: osg2vsg-utils
Architecture: any
Depends: libosg2vsg
Description: Conversion utility vulkanscenegraph
 Conversion program for converting models to vulkanscenegraph native format

Package: libosg2vsg
Architecture: any
Depends:
Description: Library files
 Runtime libraries for libosg2vsg

Package: libosg2vsg-dev
Architecture: all
Depends: libosg2vsg, libvulkan-dev, libvulkanscenegraph-dev, libfreetype-dev, libassimp-dev, libopenexr-dev, libgdal-dev, libcurl4-openssl-dev, libopenscenegraph-dev
Description: Development headers
 Development headers for libosg2vsg

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_CMAKE_EXTRA_FLAGS += -DBUILD_SHARED_LIBS=ON \
        -DCMAKE_INSTALL_LIBDIR:PATH=/usr/lib/$(DEB_HOST_MULTIARCH)
